Attribute VB_Name = "Module1"
Option Explicit

Public Sub SetButtons(frmFormName As Form, strStage As String)

    'This routine is run to set the forms buttons depending on the stage of the procedure
    'If step 1 on either form this section is run
    If strStage = "Start" Then
        frmFormName.cmdSwitch.Enabled = True
        frmFormName.cmdCancel.Caption = "&Exit"
        frmFormName.cmdBack.Enabled = False
        frmFormName.cmdNext.Enabled = True
        frmFormName.cmdFinish.Enabled = False
    
    'If step 4 of check-out or step 2 of check-in this is run
    ElseIf strStage = "End" Then
        frmFormName.cmdSwitch.Enabled = False
        frmFormName.cmdCancel.Caption = "Cancel"
        frmFormName.cmdBack.Enabled = True
        frmFormName.cmdNext.Enabled = False
        frmFormName.cmdFinish.Enabled = True
        frmFormName.cmdFinish.SetFocus
    
    'If in the middle of the checkout wizard - steps 2,3,5 this is run
    ElseIf strStage = "Mid" Then
        frmFormName.cmdSwitch.Enabled = False
        frmFormName.cmdCancel.Caption = "Cancel"
        frmFormName.cmdBack.Enabled = True
        frmFormName.cmdNext.Enabled = True
        frmFormName.cmdFinish.Enabled = False
    
    End If

End Sub

Public Sub ScanError(txtBarCodeBox As TextBox)
    
    'Run if the scanned barcode isn't recognised by the database recordset
    MsgBox "Barcode not recognized...please try again.", vbOKOnly + vbExclamation, _
        "Barcode Scan Error"
        
    'Resets the textbox for whichever step
    txtBarCodeBox.Text = ""
    txtBarCodeBox.SetFocus
    
End Sub

Public Sub SwitchPicsForward(intStep As Integer, frmFormName As Form)
    
    'Hides the current picture box and shows the next one
    frmFormName.picStep(intStep).Visible = True
    frmFormName.picStep(intStep - 1).Visible = False
   
End Sub

Public Sub SwitchPicsBackward(intStep As Integer, frmFormName As Form)
    
    'Hides the current picture box and shows the previous one
    frmFormName.picStep(intStep).Visible = True
    frmFormName.picStep(intStep + 1).Visible = False
    
End Sub

Public Sub NoScanError(txtBarCodeBox As TextBox)
    
    'Run if the textbox for the barcode scan is empty
    Dim strMsg As String
    Dim lngStyle As Long
    Dim strTitle As String
    Dim vbmResponse As VbMsgBoxResult
    
    strMsg = "Please rescan the barcode"
    lngStyle = vbOKOnly + vbExclamation
    strTitle = "Barcode Scan Error"
    vbmResponse = MsgBox(strMsg, lngStyle, strTitle)
    
    txtBarCodeBox.Text = ""
    txtBarCodeBox.SetFocus
       
        
End Sub

Public Sub cmdCancelClick(frmFormName As Form, txtBarCodeBox As TextBox)
Dim vbmResponse As VbMsgBoxResult
    'Run when the cancel button on either check-out or check-in form is run

    'At step 1 this is the exit button thus prompts if users wants to quit program
    If frmFormName.picStep(0).Visible = True Then
        
        vbmResponse = MsgBox("Are you sure you want to exit the Wrox Library Transaction Wizard", _
            vbYesNo + vbQuestion, "Verification of Exit")
           
        'If yes end program
        If vbmResponse = vbYes Then
            End
    
        'Otherwise return to program but reset textbox
        Else
            txtBarCodeBox.Text = ""
            txtBarCodeBox.SetFocus
        
        End If

    Else
        'Prompt for confirmation
        vbmResponse = MsgBox("Are you sure you want to cancel anything further on this transaction?", _
                            vbYesNo + vbQuestion, "Verification of Cancel")
    
        'If yes restart the form by reloading it
        If vbmResponse = vbYes Then
            frmFormName.Reset
            txtBarCodeBox.Text = ""
            txtBarCodeBox.SetFocus
        End If
    
    End If

End Sub
