VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "CLogger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' If using MTS use Implements MTxAS.ObjectControl
' If using COM+ use
Implements COMSVCSLib.ObjectControl

Public Enum MessageLevel
   Informational = 0
   Warning
   Critical
End Enum

Private Const LOG_FILE As String = "\logfile.txt"

Private m_dteTimestamp As Date
Private m_objContext As ObjectContext
Private m_strClassName As String
Private m_strMessage As String
Private m_strMessageCode As String
Private m_strMethodName As String

Private Sub ObjectControl_Activate()

   Set m_objContext = GetObjectContext

End Sub

Private Sub ObjectControl_Deactivate()

   Set m_objContext = Nothing

End Sub

Private Function ObjectControl_CanBePooled() As Boolean

   ObjectControl_CanBePooled = False

End Function

Public Property Get ClassName() As String

   ClassName = m_strClassName

End Property

Public Property Let ClassName(ByVal Val As String)

   m_strClassName = Val

End Property

Public Property Get Message() As String

   Message = m_strMessage

End Property

Public Property Let Message(ByVal Val As String)

   m_strMessage = Val

End Property

Public Property Get MessageCode() As String

   MessageCode = m_strMessageCode

End Property

Public Property Let MessageCode(ByVal Val As String)

   m_strMessageCode = Val

End Property

Public Property Get MethodName() As String

   MethodName = m_strMethodName

End Property

Public Property Let MethodName(ByVal Val As String)

   m_strMethodName = Val

End Property

Public Property Get Timestamp() As Date

   Timestamp = m_dteTimestamp

End Property

Public Property Let Timestamp(ByVal Val As Date)

   m_dteTimestamp = Val

End Property


Public Function Submit(ByVal Level As MessageLevel) As Boolean

   On Error GoTo Error_Submit

   Dim lngFile As Long

   lngFile = FreeFile

   Open App.Path & "\" & LOG_FILE For Append As lngFile

'  Write the data.
   Write #lngFile, "Time: " & CStr(m_dteTimestamp)
   Write #lngFile, "Class Name: " & m_strClassName
   Write #lngFile, "Method Name: " & m_strMethodName
   Write #lngFile, "Message Code: " & m_strMessageCode
   Write #lngFile, "Level: " & Level
   Write #lngFile, "Message: " & m_strMessage
   Write #lngFile, vbCrLf

   Close lngFile

   m_objContext.SetComplete

   Exit Function

Error_Submit:

   If lngFile <> 0 Then
    Close lngFile
   End If

   m_objContext.SetAbort
   Err.Raise Err.Number, "Submit", Err.Description

End Function

Public Sub Reset()

   ObjectReset

End Sub

Private Sub ObjectReset()

   On Error Resume Next

   m_dteTimestamp = Null
   m_strClassName = vbNullString
   m_strMessage = vbNullString
   m_strMessageCode = vbNullString
   m_strMethodName = vbNullString

End Sub

