VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 1  'NoTransaction
END
Attribute VB_Name = "BankLocator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Class module in data tier

Const MODULE_NAME As String = "Bank_DB.BankLocator"

Private m_objDBHelper As DBHelper

Private Sub Class_Initialize()
' Initialize the helper object to run stored procedures
   Set m_objDBHelper = CreateObject("Bank_DB.DBHelper")
End Sub

Private Sub Class_Terminate()
' Destroy the helper object
   Set m_objDBHelper = Nothing
End Sub

Public Property Get GetBank(ByVal BankID As Long) As String

  On Error GoTo ErrorHandler

  Select Case BankID
  ' Only Big Bank is implemented for the case study
  Case 1 ' BankID for Big Bank
    ' A OLEDB connection string can be used in this form
    
    'GetBank = "Provider=msdaSQL;" _
      & "DRIVER=SQL Server;" _
      & "SERVER=ianb;" _
      & "DATABASE=BigBank;" _
      & "UID=sa;PWD=;"
    
    ' Or it can be used in this form
    
    GetBank = "Provider=SQLOLEDB;Data Source=(local);Initial" _
      & " Catalog=BigBank;User Id=sa;" _
      & "Password=;Connect Timeout=3"
    
    ' Or you can use a DSN instead of a OLEDB connection string
    'GetBank = "DSN=KenWROBA"
  Case Else
    GetBank = ""
  End Select

Clean_Up:
  CtxSetComplete
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "GetBank"
  GoTo Clean_Up
End Property
