VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAuthors"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' clsAuthors - wraps up the functionality to browse and
' maintain the authors table in the Biblio database

Public Event DataChanged()

'Public members to implement properties
Public lngAu_ID As Long
Public strAuthor As String
Public intYear_Born As Integer

Private m_objRecordset As New clsRecordset

' Private members to hold connection to database,
' and to the recordset itself
Private m_recAuthors As Recordset
Private m_dbDatabase As Database

' Class event handlers

Private Sub Class_Initialize()
' When an instance of a class is created, we want to
' connect to the database and open up the Authors table.

    On Error GoTo Class_Initialize_Error
    
    Set m_dbDatabase = Workspaces(0).OpenDatabase _
    (App.Path & "\Biblio.mdb")
    Set m_recAuthors = m_dbDatabase.OpenRecordset("Authors", _
    dbOpenTable)
    
    Exit Sub
    
Class_Initialize_Error:
    MsgBox "There was a problem opening either the Biblio " & _
    "database, or the Authors table.", vbExclamation, "Problem"
    Exit Sub

End Sub

Private Sub Class_Terminate()
' When the instance of the class is destroyed, we need to
' close down the recordset, and also the connection to the
' database. Error handling is needed since there could have
' been a problem in the Initialize routine making these
' connections invalid

On Error Resume Next

m_recAuthors.Close
m_dbDatabase.Close

End Sub

' Generic Data management methods

Private Sub Reload_Members()
' Reloads the member variables (properties) with the field
' values of the current record

On Error GoTo Reload_Members_Error

With m_recAuthors
    
    lngAu_ID = .Fields("au_id")
    strAuthor = "" & .Fields("author")
    If Not IsNull(.Fields("year born")) Then
        intYear_Born = .Fields("year born")
    Else
        intYear_Born = 0
    End If
    
End With



RaiseEvent DataChanged

Exit Sub

Reload_Members_Error:
    Exit Sub
    
End Sub


Private Sub Save_Members()
' Assumes that the recordset is in either Edit or Addnew mode

    On Error GoTo Save_Members_Error
    
    With m_recAuthors
    
        .Fields("Author") = "" & strAuthor
        .Fields("Year Born") = intYear_Born
        
    End With
    
    Exit Sub
    
Save_Members_Error:

    Exit Sub
    
End Sub
Public Sub AddAsNew()
'
    With m_recAuthors
        .AddNew
        Save_Members
        .Update
    End With

End Sub

Public Sub DeleteCurrent()
'
    m_recAuthors.Delete
    On Error Resume Next
    m_recAuthors.MoveFirst
    Reload_Members

End Sub

'Class methods

Public Sub MoveNext()
    m_objRecordset.MoveNext m_recAuthors
    Reload_Members

End Sub

Public Sub MovePrevious()
    m_objRecordset.MovePrevious m_recAuthors
    Reload_Members

    
End Sub

Public Sub MoveLast()
    m_objRecordset.MoveLast m_recAuthors
    Reload_Members
End Sub

Public Sub MoveFirst()
    m_objRecordset.MoveFirst m_recAuthors
    Reload_Members
End Sub

Public Sub SaveChanges()
'
    With m_recAuthors
        .Edit
        Save_Members
        .Update
    End With
    
End Sub


