VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Mediator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Class Mediator
   Private startRect As Boolean
    Private rectSelected As Boolean
    Private drawings As Collection
    Private canvas As PictureBox
    Private selectedIndex As Integer
    Private caretakr As Caretaker
    Private rect As RectButton
 Public Sub init()
   startRect = False
   rectSelected = False
   Set drawings = New Collection
   Set caretakr = New Caretaker
   caretakr.init drawings
End Sub
Public Sub startRectangle()
 startRect = True
End Sub
Public Sub createRect(ByVal x As Integer, ByVal y As Integer)
Dim count As Integer
Dim v As VisRectangle
 unpick             'make sure no rectangle is selected
 If startRect Then  'if rect button is depressed
     count = drawings.count
     caretakr.add count 'Save previous drawing list size
     Set v = New VisRectangle   'create a rectangle
     v.init x, y
     drawings.add v             'add new element to list
     startRect = False          'done with this rectangle
     rect.setSelected False     'unclick button
     canvas.Refresh
   Else
     pickRect x, y  'if not pressed look for rect to select
   End If
End Sub
'------------------------------------------
Public Sub registerRectButton(rb As RectButton)
    Set rect = rb
End Sub
'-------------------------------------------
Public Sub registerCanvas(p As PictureBox)
 Set canvas = p
End Sub
Private Sub unpick()
   If rectSelected Then
      drawings(selectedIndex).setSelected False
      selectedIndex = 0
      rectSelected = False
      canvas.Refresh
   End If
End Sub
Public Sub pickRect(x As Integer, y As Integer)
'save current selected rectangle
'to avoid double save of undo
  Dim lastPick As Integer
  Dim v As VisRectangle
  Dim i As Integer
  If selectedIndex > 0 Then
    lastPick = selectedIndex
    End If
    unpick  'undo any selection
    'see if one is being selected
    For i = 1 To drawings.count
       Set v = drawings(i)
       If v.contains(x, y) Then 'did click inside a rectangle
          selectedIndex = i     'save it
          rectSelected = True
          If selectedIndex <> lastPick Then 'but don't save twice
            caretakr.rememberPosition drawings(selectedIndex)
          End If
          v.setSelected True   'turn on handles
          repaint            'and redraw
       End If
    Next i
End Sub
Public Sub clear()
 Set drawings = New Collection
 caretakr.clear drawings
 rectSelected = False
 selectedIndex = 0
 repaint
End Sub
Private Sub repaint()
 canvas.Refresh
End Sub
Public Sub drag(ByVal x As Integer, ByVal y As Integer)
  If rectSelected Then
     If drawings(selectedIndex).contains(x, y) Then
         drawings(selectedIndex).move x, y
         repaint
      End If
  End If
End Sub
       
'-------------------------------------------
Public Sub reDraw(g As PictureBox)
Dim i As Integer
Dim v As VisRectangle
g.FillColor = vbBlack
For i = 1 To drawings.count
    Set v = drawings(i)
    v.draw g
Next i
End Sub
        
'-------------------------------------------
Public Sub undo()
 caretakr.undo
 repaint
End Sub
        
'-------------------------------------------
    
        
        
        


