VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "clsMTSTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
    
Implements ObjectControl

Private mobjADOConnection As ADODB.Connection
Private mobjContext As ObjectContext

Private Const mcstrDatabasePath As String = "C:\Program Files\Microsoft " & _
                                            "Visual Studio\VB98\NWind.mdb"
                                            
Private Sub ObjectControl_Activate()

  Set mobjContext = GetObjectContext

End Sub

Private Function ObjectControl_CanBePooled() As Boolean

  ObjectControl_CanBePooled = False

End Function

Private Sub ObjectControl_Deactivate()

  Set mobjADOConnection = Nothing
  Set mobjContext = Nothing

End Sub

Private Function CreateInstance(ProgID As String) As Object

  On Error GoTo CreateInstanceError

  If Not mobjContext Is Nothing Then
    Set CreateInstance = mobjContext.CreateInstance(ProgID)
  Else

    Select Case ProgID

      Case "ADODB.Connection"
          Set CreateInstance = New ADODB.Connection

      Case "ADODB.Recordset"
          Set CreateInstance = New ADODB.Recordset

    End Select

  End If

  Exit Function

CreateInstanceError:

  Err.Raise Err.Number, Err.Source & " CreateInstance", Err.Description

End Function

Private Sub SetADOConnection(ByVal v_strUserID As String, _
                             ByVal v_strPassword As String, _
                             Optional ByVal v_strConnectionString As String _
                                      = "Empty")
  
  On Error GoTo SetADOConnectionError

  Set mobjADOConnection = CreateInstance("ADODB.Connection")

  With mobjADOConnection
     .CursorLocation = adUseServer
     If v_strConnectionString = "Empty" Then
         .ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                             "Persist Security Info=False;" & _
                             "Data Source=" & mcstrDatabasePath

     Else
         .ConnectionString = v_strConnectionString
     End If

     .Open
  End With
   
  Exit Sub

SetADOConnectionError:

  Dim lngErrorCounter As Long
  Dim strErrors As String

  strErrors = Err.Number & ": " & Err.Description

  If mobjADOConnection.Errors.Count > 0 Then

     For lngErrorCounter = 0 To mobjADOConnection.Errors.Count - 1
        strErrors = strErrors & _
        mobjADOConnection.Errors(lngErrorCounter).Number & _
        ": " & mobjADOConnection.Errors(lngErrorCounter).Description & _
        vbCrLf
     Next lngErrorCounter

  End If

  Err.Raise Err.Number, "SetADOConnection", strErrors

End Sub

Private Function GetADOConnection() As ADODB.Connection

  If mobjADOConnection Is Nothing Then
     Err.Raise 2001, "GetADOConnection", _
        "Trying to Get Connection prior to setting it"
  Else
     Set GetADOConnection = mobjADOConnection

  End If

End Function

Private Sub CloseADOConnection()

  With GetADOConnection
    If .State = adStateOpen Then
       .Close
    End If

  End With
  
End Sub

Public Function GetRecordset() As ADODB.Recordset

  Dim strADOConnection As String
  Dim recCustomers As ADODB.Recordset

  On Error GoTo GetRecordsetError

  strADOConnection = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                     "Data Source=C:\Program Files\Microsoft Visual " & _
                     "Studio\VB98\Nwind.mdb;Persist Security Info=False"

  SetADOConnection "", "", strADOConnection
  Set recCustomers = New ADODB.Recordset
  recCustomers.CursorLocation = adUseClient
  recCustomers.CursorType = adOpenStatic
  recCustomers.LockType = adLockPessimistic
  recCustomers.Source = "Customers"
  Set recCustomers.ActiveConnection = GetADOConnection

  recCustomers.Open
  Set recCustomers.ActiveConnection = Nothing

  Set GetRecordset = recCustomers
     
  CloseADOConnection
  Exit Function

GetRecordsetError:

  CloseADOConnection
  Err.Raise Err.Number, Err.Source & " GetRecordset", Err.Description

End Function

Public Sub ChangeRecordset(ByVal v_recCustomer As ADODB.Recordset)

  v_recCustomer.Fields("ContactTitle") = "NewValue"

End Sub

