VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "SystemUserAttributes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext

Public Function GetAttributes(ByVal UserID As Variant, ByVal SystemID As Variant, ByRef Attributes As Variant) As Variant

On Error GoTo Error_GetAttributes

Dim lngC As Long
Dim objConn As ADODB.Connection
Dim objRS As ADODB.Recordset
Dim strSQL As String
Dim vntAttributes() As Variant

GetAttributes = False

If mobjContext.IsSecurityEnabled = True Then
    If mobjContext.IsCallerInRole("PPAllowedUser") = True Then
        
        Set objConn = CreateObject("ADODB.Connection")
        Set objRS = CreateObject("ADODB.Recordset")
        If Not objConn Is Nothing Then
            objConn.Open DB_CONN
'            strSQL = "select AttributeID " & _
'                     "from PPSystemUserAttribute " & _
'                     "where UserID = '" & Trim$(CStr(UserID)) & "' " & _
'                     "and SystemID = '" & Trim$(CStr(SystemID)) & "'"
            strSQL = "select AttributeID " & _
                     "from PPSystemUserAttribute " & _
                     "where UserID = " & (CStr(UserID)) & _
                     " and SystemID = " & (CStr(SystemID))
                     
                     
            objRS.Open strSQL, objConn, adOpenStatic
            If Not objRS Is Nothing Then
                If objRS.RecordCount <> 0 Then
                    ReDim vntAttributes(0 To (objRS.RecordCount - 1)) As Variant
                    For lngC = 0 To (objRS.RecordCount - 1)
                        vntAttributes(lngC) = CLng(objRS("AttributeID"))
                        objRS.MoveNext
                    Next lngC
                    Attributes = vntAttributes
                    GetAttributes = True
                End If
                objRS.Close
                Set objRS = Nothing
            End If
            objConn.Close
            Set objConn = Nothing
        End If
        
    Else
        Err.Raise NOT_AUTHORIZED, "SystemUserAttributes_GetAttributes", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "SystemUserAttributes_GetAttributes", SECURITY_NOT_ENABLED_DESC
End If

mobjContext.SetComplete

Exit Function

Error_GetAttributes:

GetAttributes = False

If Not objRS Is Nothing Then
    Set objRS = Nothing
End If

If Not objConn Is Nothing Then
    Set objConn = Nothing
End If

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description


End Function

Private Sub ObjectControl_Activate()

Set mobjContext = GetObjectContext

End Sub


Private Function ObjectControl_CanBePooled() As Boolean

ObjectControl_CanBePooled = False

End Function

Private Sub ObjectControl_Deactivate()

Set mobjContext = Nothing

End Sub




Public Function SaveAttributes(ByVal UserID As Variant, ByVal SystemID As Variant, ByRef Attributes As Variant) As Variant

On Error GoTo Error_SaveAttributes

Dim lngC As Long
Dim objConn As ADODB.Connection
Dim objRS As ADODB.Recordset
Dim strSQL As String

SaveAttributes = "No"

If mobjContext.IsSecurityEnabled = True Then
    If mobjContext.IsCallerInRole("PPAllowedUser") = True Then
    
        Set objConn = CreateObject("ADODB.Connection")
        If Not objConn Is Nothing Then
            objConn.Open DB_CONN
            For lngC = LBound(Attributes) To UBound(Attributes)
                strSQL = "insert into PPSystemUserAttribute " & _
                         "(SystemID, UserID, AttributeID) values (" & _
                         CStr(SystemID) & ", " & _
                         CStr(UserID) & ", " & _
                         CStr(Attributes(lngC)) & ")"
                On Error Resume Next
                objConn.Execute strSQL
                On Error GoTo Error_SaveAttributes
                If objConn.Errors.Count > 0 Then
                    If objConn.Errors(0).NativeError = DUPLICATE_RECORD Then
                        '  Duplicate error - it's OK to
                        '  continue.
                        Err.Clear
                        objConn.Errors.Clear
                    Else
                        Err.Raise DUPLICATE_RECORD
                    End If
                End If
            Next lngC
            SaveAttributes = True
            objConn.Close
            Set objConn = Nothing
        End If
        
   Else
        Err.Raise NOT_AUTHORIZED, "SystemUserAttributes_SaveAttributes", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "SystemUserAttributes_GetAttributes", SECURITY_NOT_ENABLED_DESC
End If

mobjContext.SetComplete

Exit Function

Error_SaveAttributes:

SaveAttributes = False

If Not objRS Is Nothing Then
    Set objRS = Nothing
End If

If Not objConn Is Nothing Then
    Set objConn = Nothing
End If

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description


End Function

Public Function DeleteAttributes(ByVal UserID As Variant, ByVal SystemID As Variant, ByRef Attributes As Variant) As Variant

On Error GoTo Error_DeleteAttributes

Dim lngC As Long
Dim objConn As ADODB.Connection
Dim objRS As ADODB.Recordset
Dim strSQL As String

DeleteAttributes = False

If mobjContext.IsSecurityEnabled = True Then
    If mobjContext.IsCallerInRole("PPAllowedUser") = True Then

        Set objConn = CreateObject("ADODB.Connection")
        If Not objConn Is Nothing Then
            objConn.Open DB_CONN
            For lngC = LBound(Attributes) To UBound(Attributes)
                strSQL = "delete from PPSystemUserAttribute where " & _
                         "(SystemID = " & _
                         CStr(SystemID) & " " & _
                         "and UserID = " & _
                         CStr(UserID) & " " & _
                         "and AttributeID = " & _
                         CStr(Attributes(lngC)) & ")"
                objConn.Execute strSQL
            Next lngC
            DeleteAttributes = True
            objConn.Close
            Set objConn = Nothing
        End If
    
    Else
        Err.Raise NOT_AUTHORIZED, "SystemUserAttributes_DeleteAttributes", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "SystemUserAttributes_DeleteAttributes", SECURITY_NOT_ENABLED_DESC
End If

mobjContext.SetComplete

Exit Function

Error_DeleteAttributes:

DeleteAttributes = False

If Not objRS Is Nothing Then
    Set objRS = Nothing
End If

If Not objConn Is Nothing Then
    Set objConn = Nothing
End If

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description


End Function

