VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "Attribute"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Public Function GetByID(ByVal AttributeID As Variant, ByRef AttributeName As Variant, ByRef AttributeValue As Variant) As Variant

On Error GoTo Error_GetByID

Dim objConn As ADODB.Connection
Dim objRS As ADODB.Recordset
Dim strSQL As String

GetByID = False

If mobjContext.IsSecurityEnabled = True Then
   If mobjContext.IsCallerInRole("PPAllowedUser") = True Then

        Set objConn = CreateObject("ADODB.Connection")
        
        objConn.Open DB_CONN
        
        strSQL = "select AttributeName, AttributeValue " & _
                 "from PPAttribute " & _
                 "where AttributeID = " & CStr(AttributeID)
        
        Set objRS = CreateObject("ADODB.Recordset")
        objRS.Open strSQL, objConn, adOpenStatic
        
        
        If Not objRS Is Nothing Then
            If objRS.RecordCount <> 0 Then
                AttributeName = Trim$("" & objRS("AttributeName"))
                AttributeValue = Trim$("" & objRS("AttributeValue"))
                GetByID = True
            End If
            objRS.Close
            Set objRS = Nothing
        End If
        
        objConn.Close
        Set objConn = Nothing
        
    Else
        Err.Raise NOT_AUTHORIZED, "Attribute_GetByID", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "Attribute_GetByID", SECURITY_NOT_ENABLED_DESC
End If
    
mobjContext.SetComplete

Exit Function

Error_GetByID:

GetByID = False

If Not objRS Is Nothing Then
    Set objRS = Nothing
End If

If Not objConn Is Nothing Then
    Set objConn = Nothing
End If

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description

End Function


Public Function GetByVals(ByRef AttributeID As Variant, ByVal AttributeName As Variant, ByVal AttributeValue As Variant) As Variant

On Error GoTo Error_GetByVals

Dim objConn As ADODB.Connection
Dim objRS As ADODB.Recordset
Dim strSQL As String

GetByVals = False

If mobjContext.IsSecurityEnabled = True Then
   If mobjContext.IsCallerInRole("PPAllowedUser") = True Then

        Set objConn = CreateObject("ADODB.Connection")
                    
        objConn.Open DB_CONN
        
        strSQL = "select AttributeID from PPAttribute " & _
                 "where AttributeName = '" & Trim$(CStr(AttributeName)) & "' " & _
                 "and AttributeValue = '" & Trim$(CStr(AttributeValue)) & "'"
        
        Set objRS = CreateObject("ADODB.Recordset")
        objRS.Open strSQL, objConn, adOpenStatic
        
        
        If Not objRS Is Nothing Then
            If objRS.RecordCount <> 0 Then
                AttributeID = CLng(objRS("AttributeID"))
                GetByVals = True
            End If
            objRS.Close
            Set objRS = Nothing
        End If
        
        objConn.Close
        Set objConn = Nothing

    Else
        Err.Raise NOT_AUTHORIZED, "Attribute_GetByVals", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "Attribute_GetByVals", SECURITY_NOT_ENABLED_DESC
End If

mobjContext.SetComplete

Exit Function

Error_GetByVals:

GetByVals = False

If Not objRS Is Nothing Then
    Set objRS = Nothing
End If

If Not objConn Is Nothing Then
    Set objConn = Nothing
End If

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description


End Function

Public Function Save(ByVal AttributeName As Variant, ByVal AttributeValue As Variant) As Variant

On Error GoTo Error_Save

Dim blnRet As Boolean
Dim lngNewID As Long
Dim objConn As ADODB.Connection
Dim strSQL As String

Save = 0

If mobjContext.IsSecurityEnabled = True Then
   If mobjContext.IsCallerInRole("PPAllowedUser") = True Then

        Set objConn = CreateObject("ADODB.Connection")
        
        objConn.Open DB_CONN
        
        On Error Resume Next
        
        strSQL = "insert into PPAttribute " & _
                 "(AttributeName, AttributeValue) " & _
                 "values (" & _
                 "'" & Trim$(Replace(AttributeName, "'", "''")) & "', '" & _
                 Trim$(Replace(AttributeValue, "'", "''")) & "') "
        
        objConn.Execute strSQL
        
        On Error GoTo Error_Save
        
        If objConn.Errors.Count > 0 Then
            If objConn.Errors(0).NativeError = DUPLICATE_RECORD Then
                '  Duplicate error - it's OK to
                '  continue.
                Err.Clear
                objConn.Errors.Clear
            Else
                Err.Raise DUPLICATE_RECORD
            End If
        End If
        
        '  Return the new attribute ID.
        objConn.Close
        Set objConn = Nothing
        
        blnRet = GetByVals(lngNewID, AttributeName, AttributeValue)
        
        If blnRet = True Then
            Save = lngNewID
        End If
        
    Else
        Err.Raise NOT_AUTHORIZED, "Attribute_Save", NOT_AUTHORIZED_DESC
    End If
Else
    Err.Raise SECURITY_NOT_ENABLED, "Attribute_Save", SECURITY_NOT_ENABLED_DESC
End If
        
mobjContext.SetComplete

Exit Function

Error_Save:

If Not objConn Is Nothing Then
    objConn.Close
    Set objConn = Nothing
End If

Save = 0

mobjContext.SetAbort
Err.Raise Err.Number, Err.Source, Err.Description

End Function


Private Sub ObjectControl_Activate()

Set mobjContext = GetObjectContext

End Sub


Private Function ObjectControl_CanBePooled() As Boolean

ObjectControl_CanBePooled = False

End Function

Private Sub ObjectControl_Deactivate()

Set mobjContext = Nothing

End Sub
